# plot.r

n <- 100
k <- 4
pp <- c(10,20,40,60) 
# r2s <- .2
r2s <- c(.2,.8,.05)
R <- 10000
gridpts <- 40
kfolds<- 5
NumEst <- 4

load("mse1")
load("mse2")
load("mse3")

for (m.i in 1:3) {

if (m.i==1) mse=mse1 else if (m.i==2) mse=mse2 else mse=mse3

if (m.i==1) rho <- 0 else rho <- 0.5

for (r2.i in 1:length(r2s)) {
  r2 <- r2s[r2.i]
  for (p.i in 1:length(pp)) {
    p <- pp[p.i]
    if (m.i<3) {
      L1 <- matrix(1,k,1) 
      L2 <- matrix(1,p-k,1) } else {
      L1 <- as.matrix((-1)^(1:k))
      L2 <- as.matrix((-1)^(1:(p-k))) }
    varx <- t(L1)%*%(diag(k)*(1-rho)+rho)%*%L1
    b <- sqrt(r2/(1-r2)/varx)
    cc <- seq(0, b, length.out=gridpts)
    ols <- matrix(1,gridpts,1)

# windows()

plotname <- paste("plot.",m.i,".",r2.i,".",p.i,sep="")
plotnamepdf <- paste(plotname,".pdf",sep="")
plotnameeps <- paste(plotname,".eps",sep="")


par(mar=c(4, 4.5, 1, 4.5))
# par(oma=c(4,0,0,0)))

if (p==10) ym=c(.4,1.2) else if (p==20) ym=c(.2,1.2) else ym=c(0,1.2)
ym=c(0,1.3)

pdf(plotnamepdf, width = 6, height = 4 )
plot(x=cc, y=ols, type="l", xlab="c", ylab="MSE", ylim=ym, cex=1, las=1, cex.lab=1, cex.axis=1, lty="longdash", lwd=1)
lines(x=cc, y=mse[r2.i,p.i,,2], type="l", pch=22, lty="dashed", lwd=1, col="blue")
lines(x=cc, y=mse[r2.i,p.i,,3], pch=22, lty="dotdash", lwd=1, col="red")
lines(x=cc, y=mse[r2.i,p.i,,1], pch=22, lty="solid", lwd=1, col="darkgreen")
legend(x="bottomright", legend=c("OLS", "Lasso", "OLS post Lasso", "James-Stein"),inset=.01,cex=.8, box.lwd = 0, box.col = "white", bg = "white", lty=c("longdash", "dashed", "dotdash", "solid"), col=c("black", "blue", "red", "darkgreen"))
dev.off()

plot(x=cc, y=ols, type="l", xlab="c", ylab="MSE", ylim=ym, cex=1, las=1, cex.lab=1, cex.axis=1, lty="longdash", lwd=1)
lines(x=cc, y=mse[r2.i,p.i,,2], type="l", pch=22, lty="dashed", lwd=1, col="blue")
lines(x=cc, y=mse[r2.i,p.i,,3], pch=22, lty="dotdash", lwd=1, col="red")
lines(x=cc, y=mse[r2.i,p.i,,1], pch=22, lty="solid", lwd=1, col="darkgreen")
legend(x="bottomright", legend=c("OLS", "Lasso", "OLS post Lasso", "James-Stein"),inset=.01,cex=.8, box.lwd = 0, box.col = "white", bg = "white", lty=c("longdash", "dashed", "dotdash", "solid"), col=c("black", "blue", "red", "darkgreen"))
savePlot(file=plotnameeps,type="eps",dev.cur())
dev.off()


  }
}
}