# shrinkage.r
library("glmnet")

n <- 100
k <- 4
pp <- c(10,20,40,60) 
r2s <- c(.2,.8,.05)
R <- 10000
gridpts <- 40
kfolds<- 5
NumEst <- 4

m.i <- 2
mse2=array(0,dim=c(length(r2s),length(pp),gridpts,NumEst-1))

# Functions 

PostLasso <- function(y,X,coef) {
  post <- matrix(0,ncol(X),1)
  ind <- (abs(coef) > 0)
  X0 <- X[,ind]
  post[ind] <- solve(crossprod(X0,X0),crossprod(X0,y))
  return(post)
}

cv.PostLasso <- function(y,X,lambdas,kfolds) {
  n <- nrow(X)
  X1 <- cbind(matrix(1,n,1), X)
  p1 <- ncol(X1)
  nl <- length(lambdas2)
  nk <- n/kfolds
  e.post.cv <- matrix(0,n,nl)
  for (i in 1:kfolds) {
    si <- (i-1)*nk
    si <- ((si+1):(si+nk))
    ys <- y[-si,]
    Xs <- X[-si,]
    X1s <- X1[-si,]
    yf <- y[si,]
    Xf <- X1[si,]
    fit2 <- glmnet(Xs, ys, family="gaussian",lambda=lambdas2)           
    coef2 <- matrix(coef(fit2),p1,nl)
    for (j in 1:nl) {
      post.j <- PostLasso(ys,X1s,coef2[,j])
      e.post.cv[si,j] <- yf - Xf %*% post.j
    }
  }
  li <- which.min(colSums(e.post.cv^2))
  lambda=lambdas[li]
  return(lambda)
}

if (m.i==1) rho <- 0 else rho <- 0.5

for (r2.i in 1:length(r2s)) {
  r2 <- r2s[r2.i]
  for (p.i in 1:length(pp)) {
    p <- pp[p.i]
    if (m.i<3) {
      L1 <- matrix(1,k,1) 
      L2 <- matrix(1,p-k,1) } else {
      L1 <- as.matrix((-1)^(1:k))
      L2 <- as.matrix((-1)^(1:(p-k))) }
    varx <- t(L1)%*%(diag(k)*(1-rho)+rho)%*%L1
    b <- sqrt(r2/(1-r2)/varx)
    cc <- seq(0, b, length.out=gridpts)


    for (c.i in 1:gridpts) {
      c <- cc[c.i]
      beta <- rbind(L1%*%b,L2%*%c)
      beta1 <- rbind(0,beta)
      store <- matrix(0,R,NumEst)

      for (r.i in 1:R) {
        X <- matrix(rnorm(n*p,mean=0,sd=1-rho),n,p) + matrix(rnorm(n,mean=0,sd=rho),n,p)
        e <- rnorm(n)
        y <- X %*% beta + e

        X1 <- cbind(matrix(1,n,1), X)
        p1 <- ncol(X1)

        fit1 <- glmnet(X, y, family="gaussian")           
        cv <- cv.glmnet(X,y,nfolds=kfolds,alpha=1)
        lambda.lasso <- cv$lambda.min
        lasso.coef.cv <- matrix(coef(fit1, s=lambda.lasso),p1,1) 

        lambdas1 <- fit1$lambda
        lambdas2 <- lambdas1[seq(2,length(lambdas1),by=2)]
        lambda.post <- cv.PostLasso(y,X,lambdas2,kfolds)
        post.coef.cv <- PostLasso(y,X1,matrix(coef(fit1,s=lambda.post),p1,1))
             
        # James-Stein estimator

        ols.coef <- solve(crossprod(X1,X1),crossprod(X1,y))
        beta0 <- matrix(0,p1,1)
        beta0[1,1] <- mean(y)
        ehat <- y - X1%*%ols.coef          
        u1 <- X1 %*% (ols.coef-beta0)
        dn <- (n-p1)*sum(u1^2)/sum(ehat^2)
        what <- max(1-(p1-2)/dn, 0)
        stein.coef <- ols.coef * what

        mse.ols <- sum((ols.coef-beta1)^2)

        store[r.i,1]=sum((ols.coef-beta1)^2)
        store[r.i,2]=sum((stein.coef-beta1)^2)
        store[r.i,3]=sum((lasso.coef.cv-beta1)^2)
        store[r.i,4]=sum((post.coef.cv-beta1)^2)

      rm(y,e,X,X1,lambdas1,lambdas2,fit1,cv,ehat)
      gc()

      }
      amse=colMeans(store)
      mse2[r2.i,p.i,c.i,] <- amse[2:NumEst]/amse[1]
    }
    save(mse2,file="mse2")
  }
}